import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Ghost here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Enemy extends SlidingActor
{
    int changeX = 1;
    int changeY = 0;
    
    public Enemy(String color) {
        if(color.equals("red")) {
            setCostumes( new String[] {"triangleMan_red1.png", "triangleMan_red2.png" }, 14);
        } else if(color.equals("yellow")) {
            setCostumes( new String[] {"triangleMan_yellow1.png", "triangleMan_yellow2.png" }, 14);
        } else if(color.equals("green")) {
            setCostumes( new String[] {"triangleMan_green1.png", "triangleMan_green2.png" }, 14);
        } else {
            setCostumes( new String[] {"triangleMan_blue1.png", "triangleMan_blue2.png" }, 14);
        }
    }
    
    public Board getBoard() {
        return (Board)getWorld();
    }
    
    public void act() {
        super.act();
        removeTouching(Hero.class);
    }
    
    public void recalculatePosition() {
        int x = getBoardX();
        int y = getBoardY();
        
        //where should we try to go?
        int targetX, targetY;
                    
        List heroList = getBoard().getObjects(Hero.class);
        Hero hero = null;
        if(heroList.size()>0) {
            //if there's a hero on the board, move towards him/her
            hero = (Hero)heroList.get(0);
            targetX = hero.getBoardX();
            targetY = hero.getBoardY();
        } else {
            //otherwise, just migrate towards the center
            targetX = 11;
            targetY = 11;
        }
        
        //we're about to pick what direction to move in.
        //should we change direction? Let's express this a percent from 0-100:
        int shouldUseSameDirection = Greenfoot.getRandomNumber(100);
        if(getBoard().isWall(x+changeX, y+changeY)) {
            //we can't go forward in the direction we've been moving, so 
            //we HAVE to change direction:
            shouldUseSameDirection = 0;
        }
        
        if(shouldUseSameDirection<10) {
            //we're going to change direction:
            int newChangeX, newChangeY;
            
            //first: try to aim directly for (targetX, targetY)
            int changeInX = Math.abs(x - targetX);
            int changeInY = Math.abs(y - targetY);
            if(targetX>x && targetY>y) {
                if( changeInX > changeInY ) {
                    newChangeX = 1;
                    newChangeY = 0;
                } else {
                    newChangeX = 0;
                    newChangeY = 1;
                }
            } else if(targetX>x && targetY<y) {
                if( changeInX > changeInY ) {
                    newChangeX = 1;
                    newChangeY = 0;
                } else {
                    newChangeX = 0;
                    newChangeY = -1;
                }
            } else if(targetX<x && targetY>y) {
                if( changeInX > changeInY ) {
                    newChangeX = -1;
                    newChangeY = 0;
                } else {
                    newChangeX = 0;
                    newChangeY = 1;
                }
            } else if(targetX<x && targetY<y) {
                if( changeInX > changeInY ) {
                    newChangeX = -1;
                    newChangeY = 0;
                } else {
                    newChangeX = 0;
                    newChangeY = -1;
                }
            } else if(targetX<x) {
                newChangeX = -1;
                newChangeY = 0;
            } else if(targetX>x) {
                newChangeX = 1;
                newChangeY = 0;
            } else if(targetY<y) {
                newChangeX = 0;
                newChangeY = -1;
            } else { // probably (targetY>y)
                newChangeX = 0;
                newChangeY = 1;
            }
            
            boolean isNewDirectionOK = isNewDirectionOK(newChangeX, newChangeY);
            
            while(!isNewDirectionOK) {
                int random = Greenfoot.getRandomNumber(4);
                if(random==0) {
                    newChangeX = 1;
                    newChangeY = 0;
                } else if(random==1) {
                    newChangeX = -1;
                    newChangeY = 0;
                } else if(random==2) {
                    newChangeX = 0;
                    newChangeY = 1;
                } else {
                    newChangeX = 0;
                    newChangeY = -1;
                }
                
                isNewDirectionOK = isNewDirectionOK(newChangeX, newChangeY);
            }
            changeX = newChangeX;
            changeY = newChangeY;
        }
        slideToBoardPosition(x + changeX, y + changeY, 18);
    }
    
    public boolean isNewDirectionOK(int newChangeX,int newChangeY) {
        int x = getBoardX();
        int y = getBoardY();
        if(newChangeX==changeX && newChangeY==changeY) {
            //nothing really changed, not OK:
            return false;
        }
        if( getBoard().isWall(x + newChangeX, y + newChangeY) ) {
            //we can't really go this way.
            return false;
        }
        return true;
    }
}
